<template>
  <div>
        <v-container>
          <v-row no-gutters>
              <v-btn icon @click="applyAtras" class="mr-2">
                <v-icon color="primary" x-large>
                  mdi-chevron-left
                </v-icon>
              </v-btn>
              <div class="text-h4">
                {{ title }}
              </div>
          </v-row>
        </v-container>
        <v-container>
          <v-row align="center">
            <v-col md="9">
              <div class="text-h5">Grabación</div>
            </v-col>
          </v-row>
        </v-container>

        <details-card>
          <div class="player-container" v-if="transcriptionState==1">
            <vue-core-video-player
              :src="videoUrl"
              v-if="videoUrl"
              ref="coreplayer">
            </vue-core-video-player>
          </div>
          <div class="player-container" v-if="transcriptionState==0">
            <div class="text-h2" align="center" style="color: #1ecd96">Transcripción en proceso</div>
          </div>
          <div class="player-container" v-if="transcriptionState==-1">
            <div class="text-h2" align="center" style="color: #1ecd96">Sesión no iniciada</div>
          </div>
        </details-card>

        <v-container>
          <v-row align="center">
            <v-col md="8">
              <div class="text-h5">Dialogo de la videollamada</div>
            </v-col>
          </v-row>
        </v-container>

        <v-container v-if="transcriptionState==1">
          <v-card height="500px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <v-card-text>
              <v-row v-for="(item, idx) in dialog" :key="idx">
                <v-col md="2">
                  <div class="text-h6 font-weight-regular">{{item.speaker}}</div>
                </v-col>
                <v-col md="2" align="right">
                  <v-btn text color="primary" @click="seekVideo(item.time)" class="text-h6 font-weight-regular timeClickeable">{{obtenerTiempoFormato(item)}}</v-btn>
                </v-col>
                <v-col md="8">
                  <text-highlight :queries="queries" class="text-h6 font-weight-regular">{{item.text}}</text-highlight>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-container>
        <v-container v-if="transcriptionState==0">
          <v-card height="150px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <v-card-text>
              <div class="text-h2" align="center" style="color: #1ecd96">Transcripción en proceso</div>
            </v-card-text>
          </v-card>
        </v-container>
        <v-container v-if="transcriptionState==-1">
          <v-card height="150px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <v-card-text>
              <div class="text-h2" align="center" style="color: #1ecd96">Sesión no iniciada</div>
            </v-card-text>
          </v-card>
        </v-container>

        <v-container>
          <v-row>
            <v-col md="6">
              <div class="text-h5">Análisis de Resultados</div>
            </v-col>
          </v-row>
        </v-container>

        <v-container v-if="analysisState==-1">
          <v-card height="150px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <div class="text-h2" align="center" style="color: #1ecd96">Sesión no iniciada</div>
          </v-card>
        </v-container>
        <v-container v-if="analysisState==0">
          <v-card height="150px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <div class="text-h2" align="center" style="color: #1ecd96">Análisis en proceso</div>
          </v-card>
        </v-container>
        <v-container v-if="analysisState==1">
          <v-card height="600px" class="scroll pa-5" style="border-color: #1ecd96" outlined>
            <v-row>
              <v-col md="6">
                <v-btn large color="primary" rounded v-on:click="applySelected"> Aplicar </v-btn>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <v-treeview
                  v-model="selection"
                  selectable="selectable"
                  selected-color="primary"
                  :items="items.palabras"
                  @update:active="onUpdate"
                ></v-treeview>
              </v-col>
              <v-col md="8">
                <details-card>
                  <apexchart
                    type="bar"
                    height="350"
                    :options="chartOptionsPalabras"
                    :series="seriesPalabras"
                  ></apexchart>
                </details-card>
                <details-card>
                  <apexchart
                    type="bar"
                    height="350"
                    :options="chartOptionsClusters"
                    :series="seriesClusters"
                  ></apexchart>
                </details-card>
              </v-col>
            </v-row>
          </v-card>
        </v-container>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from "vuex";
import DetailsCard from "~/components/Cards/DetailsCard.vue";
import { pluck, map, indexBy, prop, __, flatten } from 'ramda';


export default {
  name: "Transcription",
  components: {
    "details-card": DetailsCard,
  },
  data() {
    return {
      title: "Transcripción",
      queries: [],
      compmlete_text: "",
      selection: [],
      wordItems: [],
      allItems: [],
      allClusters: [],
      items2: [
        {
          id: 1,
          name: "Palabras obtenidas",
          children: [
            {
              id: 2,
              name: "Antropologia",
              children: [
                { id: 4, name: "Basic" },
                { id: 5, name: "Advanced" },
                { id: 6, name: "All" },
              ],
            },
            {
              id: 3,
              name: "Bueno",
              children: [
                { id: 7, name: "layouts" },
                { id: 8, name: "techniques" },
                { id: 9, name: "about" },
              ],
            },
          ],
        },
      ],
      seriesPalabras: [
        {
          data: [0],
        }
      ],
      seriesClusters: [
        {
          data: [],
        }
      ],
      chartOptionsPalabras: {
        title: {
          text: "Relevancia de los términos en la videollamada"
        },
        chart: {
          type: "bar",
          height: 350,
        },
        plotOptions: {
          bar: {
            borderRadius: 4,
            horizontal: true,
            distributed: true,
          },
        },

        dataLabels: {
          enabled: false,
        },
        xaxis: {
          categories: [''
          ],
          title: {
            text: "Nivel de Relevancia de los Términos (%)"
          }
        },
        yaxis: {
          opposite: false,
          title: {
            text: "Términos Relevantes"
          },
        }
      },
      chartOptionsClusters: {
        title: {
          text: "Polaridad de los grupos de términos"
        },
        chart: {
          type: "bar",
          height: 350,
        },
        plotOptions: {
          bar: {
            borderRadius: 4,
            horizontal: true,
            distributed: true,
          },
        },

        dataLabels: {
          enabled: false,
        },
        xaxis: {
          categories: [
          ],
          min: -1,
          max: 1,
          decimalsInFloat: 2,
          title: {
            text: "Nivel de Polaridad"
          }
        },
        yaxis: {
          title: {
            text: "Grupos de términos"
          }
        }
      },
    };
  },
  computed: {
    ...mapState({
      dialog: (state) => state.transcription.dialog,
      analysis: (state) => state.transcription.analysis,
      videoUrl: (state) => state.transcription.videoUrl,
      transcriptionId: (state) => state.transcription.transcriptionId,
      transcriptionState: (state) => state.transcription.transcriptionState,
      analysisState: (state) => state.transcription.analysisState,
      estadoSesion: (state) => state.transcription.estadoSesion,
    }),
    ...mapGetters({
      videocallUuid: 'specialist/appointments/getVideocallUuid',
    }),
    session() {
      return this.$route.params.id;
    },
    items() {
      let items = []
      let polaridades = []
      let leafChildren = []
      let id = 0
      for (let index in this.analysis) {
        console.log("ITERANDO...", this.analysis[index])
        const words = this.analysis[index].words
        const name = words[0].word
        const clusterPolarity = this.analysis[index].cluster_polarity
        console.log("cluster_polarity", clusterPolarity);
        const children = words.map(el => {
          id++
          return {
            id,
            name: el.word,
            weight: el.weight,
            ocurrence_times: el.ocurrence_times
          }
        })
        id++
        items.push({ id, name, children })
        polaridades.push( {id, name: name, weight: clusterPolarity} )
      }
      const allChildren = pluck('children', items);
      //const allChildren = leafChildren
      this.allItems = indexBy(prop('id'), flatten(allChildren)); // {'1': {}, '2': {}}
      this.allClusters = polaridades;

      const itemsTree = [{
        id: 0,
        name: "Grupos de Términos",
        children: items }]
      // console.log('items', JSON.stringify(items, null, ' '))

      const varvar = {
        palabras : itemsTree,
        polaridades : polaridades
      }

      console.log("ITEMS BE LIKE", varvar);

      //return itemsTree
      return varvar
    },
    selectedItems() {
      console.log("SELECTED", this.allItems, this.selection);
      console.log(this.selection);
      const allIt = map(prop(__, this.allItems), this.selection);
      console.log("allIt", allIt);
      return allIt;
    }
  },
  mounted() {

    this.initialize();
  },
  methods: {
    ...mapActions({
      getTranscription: 'transcription/getTranscription',
      getAnalysis: 'transcription/getAnalysis'
    }),
    seekVideo(instant) {
      console.log("AAA");
      console.log(instant);
      this.$refs.coreplayer.$refs["vcp-video"].currentTime = instant;
    },
    async initialize() {

      const videocallUuidUuid = this.videocallUuidUuid
      //const videocallUuid = 'ffed380b-82dc-4ad5-b887-e567ca1282ab'
      //const transcriptionId = 2
      //const appointmentId = 49
      //const transcriptionId = 3
      //const appointmentId = 100
      const videocallUuid = '2e5970ac-12f8-4da6-9b74-3390b56d5ecf'

      const appointmentId = this.$route.params.id;
      //console.log(videocallUuid,transcriptionId)
      await this.getTranscription({ sessionId: appointmentId });
      const estadoSesion = this.estadoSesion;
      if (estadoSesion == 0){
        return;
      }
      const transcriptionId = this.transcriptionId;
      console.log("transcriptionId from store", transcriptionId);
      await this.getAnalysis({ transcriptionId, videocallUuid })

      let clusters = pluck( 'name', this.allClusters )
      console.log("this.allclusters", this.allClusters);
      let pesosClusters = pluck( 'weight', this.allClusters )

      this.seriesClusters = [{ data: pesosClusters.map(function(e) {return e.toFixed(2);})}];
      //console.log('series', JSON.stringify(this.series, null, ' '))
      this.chartOptionsClusters =  {... this.chartOptionsClusters, xaxis:{categories: clusters, min:-1, max:1, decimalsInFloat:2}}

    },
    obtenerTiempoFormato(item) {
      return new Date(item.time * 1000).toISOString().substr(11, 8);
    },
    onUpdate(activeItems) {
      console.log("ON UPDATE ", activeItems);
    },
    applyAtras() {
      this.$router.push(`/especialista/sesion/${this.$route.params.id}`);
    },
    applySelected() {
      console.log("transcriptionState", this.transcriptionState);
      console.log("analysisState", this.analysisState);

      if (this.selectedItems.length == 0){
        this.seriesPalabras = [{ data: [0]}];
        console.log('series', JSON.stringify(this.series, null, ' '));
        this.chartOptionsPalabras =  {... this.chartOptionsPalabras, xaxis:{categories: ['']}, yaxis:{title:'aaa'}};
        return;
      }


      let palabras = pluck( 'name', this.selectedItems )
      let queriesL = [];
      palabras.forEach(function(elem) {
          queriesL.push( new RegExp('\\b' + elem + '\\b') );
      });
      this.queries = queriesL;

      let clusters = pluck( 'name', this.allClusters )
      console.log("this.allclusters", this.allClusters);
      let pesosPalabras = pluck( 'weight', this.selectedItems )
      let pesosClusters = pluck( 'weight', this.allClusters )

      var list = [];
      for (var j = 0; j < palabras.length; j++)
          list.push({'palabras': palabras[j], 'pesosPalabras': pesosPalabras[j]});

      //2) sort:
      list.sort(function(a, b) {
          return ((a.pesosPalabras > b.pesosPalabras) ? -1 : ((a.pesosPalabras == b.pesosPalabras) ? 0 : 1));
          //Sort could be modified to, for example, sort on the age
          // if the name is the same.
      });

      //3) separate them back out:
      for (var k = 0; k < list.length; k++) {
          palabras[k] = list[k].palabras;
          pesosPalabras[k] = list[k].pesosPalabras;
      }

      this.seriesPalabras = [{ data: pesosPalabras.map(function(e) {return (100*e).toFixed(2);})}];
      console.log('series', JSON.stringify(this.series, null, ' '))
      this.chartOptionsPalabras =  {... this.chartOptionsPalabras, xaxis:{categories: palabras}, yaxis: {showAlways: false}}
    }
  },
};
</script>

<style scoped>
.button.v-treeview-node__toggle + button.v-treeview-node__checkbox {
  display: none !important;
}
.scroll {
  overflow-y: scroll;
  border-color: #1ecd96;
}
.timeClickeable {
  cursor: pointer;
}
</style>
